Apache NiFi Registry REST API

REST API definition for Apache NiFi Registry web services
More information: https://nifi.apache.org
Contact Info: dev@nifi.apache.org
Version: 2.12.0
Apache 2.0
https://www.apache.org/licenses/LICENSE-2.0.html

Access

Methods

[ Jump to Models ]

Table of Contents

About

Access

BucketBundles

BucketFlows

Buckets

Bundles

Config

ExtensionRepository

Extensions

Flows

Items

Policies

Tenants

About

Up
get /about
Get version (getVersion)
Gets the NiFi Registry version.

Return type

RegistryAbout

Example data

Content-Type: application/json
{
  "registryAboutVersion" : "registryAboutVersion"
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

default

RegistryAbout

Access

Up
post /access/token
Create token trying all providers (createAccessTokenByTryingAllProviders)
Creates a token for accessing the REST API via auto-detected method of verifying client identity claim credentials. The token returned is formatted as a JSON Web Token (JWT). The token is base64 encoded and comprised of three parts. The header, the body, and the signature. The expiration of the token is a contained within the body. The token can be used in the Authorization header in the format 'Authorization: Bearer '.

Return type

String

Example data

Content-Type: application/json
""

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

201

String

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid. The NiFi Registry may not be configured to support login with username/password.

500

NiFi Registry was unable to complete the request because an unexpected error occurred.

Up
post /access/token/login
Create token using basic auth (createAccessTokenUsingBasicAuthCredentials)
Creates a token for accessing the REST API via username/password. The user credentials must be passed in standard HTTP Basic Auth format. That is: 'Authorization: Basic ', where is the base64 encoded value of ':'. The token returned is formatted as a JSON Web Token (JWT). The token is base64 encoded and comprised of three parts. The header, the body, and the signature. The expiration of the token is a contained within the body. The token can be used in the Authorization header in the format 'Authorization: Bearer '.

Return type

String

Example data

Content-Type: application/json
""

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

201

String

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid. The NiFi Registry may not be configured to support login with username/password.

500

NiFi Registry was unable to complete the request because an unexpected error occurred.

Up
post /access/token/identity-provider
Create token using identity provider (createAccessTokenUsingIdentityProviderCredentials)
Creates a token for accessing the REST API via a custom identity provider. The user credentials must be passed in a format understood by the custom identity provider, e.g., a third-party auth token in an HTTP header. The exact format of the user credentials expected by the custom identity provider can be discovered by 'GET /access/token/identity-provider/usage'. The token returned is formatted as a JSON Web Token (JWT). The token is base64 encoded and comprised of three parts. The header, the body, and the signature. The expiration of the token is a contained within the body. The token can be used in the Authorization header in the format 'Authorization: Bearer '.

Return type

String

Example data

Content-Type: application/json
""

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

201

String

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid. The NiFi Registry may not be configured to support login with customized credentials.

500

NiFi Registry was unable to complete the request because an unexpected error occurred.

Up
post /access/token/kerberos
Create token using kerberos (createAccessTokenUsingKerberosTicket)
Creates a token for accessing the REST API via Kerberos Service Tickets or SPNEGO Tokens (which includes Kerberos Service Tickets). The token returned is formatted as a JSON Web Token (JWT). The token is base64 encoded and comprised of three parts. The header, the body, and the signature. The expiration of the token is a contained within the body. The token can be used in the Authorization header in the format 'Authorization: Bearer '.

Return type

String

Example data

Content-Type: application/json
""

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

201

String

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid. The NiFi Registry may not be configured to support login Kerberos credentials.

500

NiFi Registry was unable to complete the request because an unexpected error occurred.

Up
get /access
Get access status (getAccessStatus)
Returns the current client's authenticated identity and permissions to top-level resources

Return type

CurrentUser

Example data

Content-Type: application/json
{
  "oidcloginSupported" : true,
  "resourcePermissions" : {
    "anyTopLevelResource" : {
      "canRead" : true,
      "canDelete" : true,
      "canWrite" : true
    }
  },
  "identity" : "identity",
  "anonymous" : true,
  "loginSupported" : true
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

CurrentUser

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid. The NiFi Registry might be running unsecured.

Up
get /access/token/identity-provider/usage
Get identity provider usage (getIdentityProviderUsageInstructions)
Provides a description of how the currently configured identity provider expects credentials to be passed to POST /access/token/identity-provider

Return type

String

Example data

Content-Type: application/json
""

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

String

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid. The NiFi Registry may not be configured to support login with customized credentials.

500

NiFi Registry was unable to complete the request because an unexpected error occurred.

Up
delete /access/logout
Performs a logout for other providers that have been issued a JWT. (logout)
NOTE: This endpoint is subject to change as NiFi Registry and its REST API evolve.

Responses

200

User was logged out successfully.

401

Authentication token provided was empty or not in the correct JWT format.

500

Client failed to log out.

Up
get /access/logout/complete
Completes the logout sequence. (logoutComplete)
NOTE: This endpoint is subject to change as NiFi Registry and its REST API evolve.

Responses

200

User was logged out successfully.

401

Authentication token provided was empty or not in the correct JWT format.

500

Client failed to log out.

Up
get /access/oidc/callback
Redirect/callback URI for processing the result of the OpenId Connect login sequence. (oidcCallback)
NOTE: This endpoint is subject to change as NiFi Registry and its REST API evolve.

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

default response

Up
post /access/oidc/exchange
Retrieves a JWT following a successful login sequence using the configured OpenId Connect provider. (oidcExchange)
NOTE: This endpoint is subject to change as NiFi Registry and its REST API evolve.

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

default response

Up
get /access/oidc/logout
Performs a logout in the OpenId Provider. (oidcLogout)
NOTE: This endpoint is subject to change as NiFi Registry and its REST API evolve.

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

default response

Up
get /access/oidc/logout/callback
Redirect/callback URI for processing the result of the OpenId Connect logout sequence. (oidcLogoutCallback)
NOTE: This endpoint is subject to change as NiFi Registry and its REST API evolve.

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

default response

Up
get /access/oidc/request
Initiates a request to authenticate through the configured OpenId Connect provider. (oidcRequest)
NOTE: This endpoint is subject to change as NiFi Registry and its REST API evolve.

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

default response

Up
post /access/token/identity-provider/test
Test identity provider (testIdentityProviderRecognizesCredentialsFormat)
Tests the format of the credentials against this identity provider without preforming authentication on the credentials to validate them. The user credentials should be passed in a format understood by the custom identity provider as defined by 'GET /access/token/identity-provider/usage'.

Return type

String

Example data

Content-Type: application/json
""

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

String

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

The format of the credentials were not recognized by the currently configured identity provider.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid. The NiFi Registry may not be configured to support login with customized credentials.

500

NiFi Registry was unable to complete the request because an unexpected error occurred.

BucketBundles

Up
post /buckets/{bucketId}/bundles/{bundleType}
Create extension bundle version (createExtensionBundleVersion)

Creates a version of an extension bundle by uploading a binary artifact. If an extension bundle already exists in the given bucket with the same group id and artifact id as that of the bundle being uploaded, then it will be added as a new version to the existing bundle. If an extension bundle does not already exist in the given bucket with the same group id and artifact id, then a new extension bundle will be created and this version will be added to the new bundle. Client's may optionally supply a SHA-256 in hex format through the multi-part form field 'sha256'. If supplied, then this value will be compared against the SHA-256 computed by the server, and the bundle will be rejected if the values do not match. If not supplied, the bundle will be accepted, but will be marked to indicate that the client did not supply a SHA-256 during creation.

NOTE: This endpoint is subject to change as NiFi Registry and its REST API evolve.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier
bundleType (required)
Path Parameter — The type of the bundle

Consumes

This API call consumes the following media types via the Content-Type request header:

Form parameters

file (optional)
Form Parameter —
sha256 (optional)
Form Parameter —

Return type

BundleVersion

Example data

Content-Type: application/json
{
  "bucket" : {
    "identifier" : "identifier",
    "allowBundleRedeploy" : true,
    "permissions" : {
      "canRead" : true,
      "canDelete" : true,
      "canWrite" : true
    },
    "createdTimestamp" : 1,
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "name" : "name",
    "description" : "description",
    "allowPublicRead" : true,
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 6
    }
  },
  "filename" : "filename",
  "link" : {
    "rel" : "rel",
    "params" : {
      "key" : "params"
    },
    "title" : "title",
    "type" : "type",
    "uri" : "http://example.com/aeiou",
    "uriBuilder" : { },
    "rels" : [ "rels", "rels" ]
  },
  "versionMetadata" : {
    "sha256" : "sha256",
    "buildInfo" : {
      "buildBranch" : "buildBranch",
      "builtBy" : "builtBy",
      "buildRevision" : "buildRevision",
      "buildTag" : "buildTag",
      "built" : 0,
      "buildTool" : "buildTool",
      "buildFlags" : "buildFlags"
    },
    "author" : "author",
    "groupId" : "groupId",
    "bundleId" : "bundleId",
    "description" : "description",
    "bucketId" : "bucketId",
    "version" : "version",
    "sha256Supplied" : true,
    "contentSize" : 0,
    "artifactId" : "artifactId",
    "id" : "id",
    "systemApiVersion" : "systemApiVersion",
    "timestamp" : 1
  },
  "bundle" : {
    "artifact" : "artifact",
    "version" : "version",
    "group" : "group"
  },
  "dependencies" : [ {
    "groupId" : "groupId",
    "artifactId" : "artifactId",
    "version" : "version"
  }, {
    "groupId" : "groupId",
    "artifactId" : "artifactId",
    "version" : "version"
  } ]
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

BundleVersion

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
get /buckets/{bucketId}/bundles
Get extension bundles by bucket (getExtensionBundles)
NOTE: This endpoint is subject to change as NiFi Registry and its REST API evolve.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier

Return type

array[Bundle]

Example data

Content-Type: application/json
[ {
  "artifact" : "artifact",
  "version" : "version",
  "group" : "group"
}, {
  "artifact" : "artifact",
  "version" : "version",
  "group" : "group"
} ]

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

BucketFlows

Up
post /buckets/{bucketId}/flows
Create flow (createFlow)
Creates a flow in the given bucket. The flow id is created by the server and populated in the returned entity.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body VersionedFlow (required)
Body Parameter — The details of the flow to create.

Return type

VersionedFlow

Example data

Content-Type: application/json
{
  "versionCount" : 0,
  "bucketName" : "bucketName",
  "identifier" : "identifier",
  "permissions" : {
    "canRead" : true,
    "canDelete" : true,
    "canWrite" : true
  },
  "createdTimestamp" : 1,
  "link" : {
    "rel" : "rel",
    "params" : {
      "key" : "params"
    },
    "title" : "title",
    "type" : "type",
    "uri" : "http://example.com/aeiou",
    "uriBuilder" : { },
    "rels" : [ "rels", "rels" ]
  },
  "name" : "name",
  "description" : "description",
  "modifiedTimestamp" : 1,
  "bucketIdentifier" : "bucketIdentifier",
  "type" : "Flow",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 6
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

VersionedFlow

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
post /buckets/{bucketId}/flows/{flowId}/versions
Create flow version (createFlowVersion)
Creates the next version of a flow. The version number of the object being created must be the next available version integer. Flow versions are immutable after they are created.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier
flowId (required)
Path Parameter — The flow identifier

Consumes

This API call consumes the following media types via the Content-Type request header:

Request body

body VersionedFlowSnapshot (required)
Body Parameter — The new versioned flow snapshot.

Query parameters

preserveSourceProperties (optional)
Query Parameter — Whether source properties like author should be kept

Return type

VersionedFlowSnapshot

Example data

Content-Type: application/json
{
  "bucket" : {
    "identifier" : "identifier",
    "allowBundleRedeploy" : true,
    "permissions" : {
      "canRead" : true,
      "canDelete" : true,
      "canWrite" : true
    },
    "createdTimestamp" : 1,
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "name" : "name",
    "description" : "description",
    "allowPublicRead" : true,
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 6
    }
  },
  "externalControllerServices" : {
    "key" : {
      "identifier" : "identifier",
      "name" : "name"
    }
  },
  "snapshotMetadata" : {
    "flowIdentifier" : "flowIdentifier",
    "comments" : "comments",
    "author" : "author",
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "bucketIdentifier" : "bucketIdentifier",
    "version" : 0,
    "timestamp" : 1
  },
  "flowContents" : {
    "processors" : [ {
      "autoTerminatedRelationships" : [ "autoTerminatedRelationships", "autoTerminatedRelationships" ],
      "bulletinLevel" : "bulletinLevel",
      "executionNode" : "executionNode",
      "runDurationMillis" : 1,
      "propertyDescriptors" : { },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "maxBackoffPeriod" : "maxBackoffPeriod",
      "yieldDuration" : "yieldDuration",
      "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "concurrentlySchedulableTaskCount" : 7,
      "retryCount" : 1,
      "penaltyDuration" : "penaltyDuration",
      "backoffMechanism" : "backoffMechanism",
      "schedulingStrategy" : "schedulingStrategy",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "schedulingPeriod" : "schedulingPeriod",
      "style" : {
        "key" : "style"
      },
      "groupIdentifier" : "groupIdentifier",
      "properties" : {
        "key" : "properties"
      }
    }, {
      "autoTerminatedRelationships" : [ "autoTerminatedRelationships", "autoTerminatedRelationships" ],
      "bulletinLevel" : "bulletinLevel",
      "executionNode" : "executionNode",
      "runDurationMillis" : 1,
      "propertyDescriptors" : { },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "maxBackoffPeriod" : "maxBackoffPeriod",
      "yieldDuration" : "yieldDuration",
      "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "concurrentlySchedulableTaskCount" : 7,
      "retryCount" : 1,
      "penaltyDuration" : "penaltyDuration",
      "backoffMechanism" : "backoffMechanism",
      "schedulingStrategy" : "schedulingStrategy",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "schedulingPeriod" : "schedulingPeriod",
      "style" : {
        "key" : "style"
      },
      "groupIdentifier" : "groupIdentifier",
      "properties" : {
        "key" : "properties"
      }
    } ],
    "scheduledState" : "ENABLED",
    "processGroups" : [ null, null ],
    "outputPorts" : [ null, null ],
    "funnels" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier"
    } ],
    "versionedFlowCoordinates" : {
      "registryId" : "registryId",
      "storageLocation" : "storageLocation",
      "bucketId" : "bucketId",
      "branch" : "branch",
      "flowId" : "flowId",
      "version" : "version",
      "latest" : true
    },
    "connections" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "prioritizers" : [ "prioritizers", "prioritizers" ],
      "comments" : "comments",
      "flowFileExpiration" : "flowFileExpiration",
      "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
      "loadBalanceCompression" : "loadBalanceCompression",
      "destination" : {
        "comments" : "comments",
        "groupId" : "groupId",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "id" : "id",
        "type" : "PROCESSOR"
      },
      "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
      "loadBalanceStrategy" : "loadBalanceStrategy",
      "labelIndex" : 5,
      "bends" : [ {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      }, {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      } ],
      "backPressureObjectThreshold" : 0,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "partitioningAttribute" : "partitioningAttribute",
      "zIndex" : 5
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "prioritizers" : [ "prioritizers", "prioritizers" ],
      "comments" : "comments",
      "flowFileExpiration" : "flowFileExpiration",
      "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
      "loadBalanceCompression" : "loadBalanceCompression",
      "destination" : {
        "comments" : "comments",
        "groupId" : "groupId",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "id" : "id",
        "type" : "PROCESSOR"
      },
      "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
      "loadBalanceStrategy" : "loadBalanceStrategy",
      "labelIndex" : 5,
      "bends" : [ {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      }, {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      } ],
      "backPressureObjectThreshold" : 0,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "partitioningAttribute" : "partitioningAttribute",
      "zIndex" : 5
    } ],
    "logFileSuffix" : "logFileSuffix",
    "parameterContextName" : "parameterContextName",
    "componentType" : "CONNECTION",
    "identifier" : "identifier",
    "defaultBackPressureObjectThreshold" : 2,
    "comments" : "comments",
    "executionEngine" : "STANDARD",
    "defaultBackPressureDataSizeThreshold" : "defaultBackPressureDataSizeThreshold",
    "labels" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "width" : 3.616076749251911,
      "instanceIdentifier" : "instanceIdentifier",
      "style" : {
        "key" : "style"
      },
      "label" : "label",
      "groupIdentifier" : "groupIdentifier",
      "height" : 9.301444243932576,
      "zIndex" : 2
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "width" : 3.616076749251911,
      "instanceIdentifier" : "instanceIdentifier",
      "style" : {
        "key" : "style"
      },
      "label" : "label",
      "groupIdentifier" : "groupIdentifier",
      "height" : 9.301444243932576,
      "zIndex" : 2
    } ],
    "controllerServices" : [ {
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "bulletinLevel" : "bulletinLevel",
      "propertyDescriptors" : {
        "key" : {
          "resourceDefinition" : {
            "resourceTypes" : [ "FILE", "FILE" ],
            "cardinality" : "SINGLE"
          },
          "displayName" : "displayName",
          "identifiesControllerService" : true,
          "name" : "name",
          "dynamic" : true,
          "sensitive" : true,
          "listenPortDefinition" : {
            "applicationProtocols" : [ "applicationProtocols", "applicationProtocols" ],
            "transportProtocol" : "TCP"
          }
        }
      },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "componentState" : {
        "localNodeStates" : [ {
          "state" : {
            "key" : "state"
          }
        }, {
          "state" : {
            "key" : "state"
          }
        } ],
        "clusterState" : {
          "key" : "clusterState"
        }
      },
      "controllerServiceApis" : [ {
        "type" : "type"
      }, {
        "type" : "type"
      } ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "properties" : {
        "key" : "properties"
      }
    }, {
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "bulletinLevel" : "bulletinLevel",
      "propertyDescriptors" : {
        "key" : {
          "resourceDefinition" : {
            "resourceTypes" : [ "FILE", "FILE" ],
            "cardinality" : "SINGLE"
          },
          "displayName" : "displayName",
          "identifiesControllerService" : true,
          "name" : "name",
          "dynamic" : true,
          "sensitive" : true,
          "listenPortDefinition" : {
            "applicationProtocols" : [ "applicationProtocols", "applicationProtocols" ],
            "transportProtocol" : "TCP"
          }
        }
      },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "componentState" : {
        "localNodeStates" : [ {
          "state" : {
            "key" : "state"
          }
        }, {
          "state" : {
            "key" : "state"
          }
        } ],
        "clusterState" : {
          "key" : "clusterState"
        }
      },
      "controllerServiceApis" : [ {
        "type" : "type"
      }, {
        "type" : "type"
      } ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "properties" : {
        "key" : "properties"
      }
    } ],
    "defaultFlowFileExpiration" : "defaultFlowFileExpiration",
    "flowFileConcurrency" : "flowFileConcurrency",
    "flowFileOutboundPolicy" : "flowFileOutboundPolicy",
    "name" : "name",
    "inputPorts" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "allowRemoteAccess" : true,
      "concurrentlySchedulableTaskCount" : 7,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "portFunction" : "STANDARD",
      "groupIdentifier" : "groupIdentifier",
      "type" : "INPUT_PORT",
      "scheduledState" : "ENABLED"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "allowRemoteAccess" : true,
      "concurrentlySchedulableTaskCount" : 7,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "portFunction" : "STANDARD",
      "groupIdentifier" : "groupIdentifier",
      "type" : "INPUT_PORT",
      "scheduledState" : "ENABLED"
    } ],
    "instanceIdentifier" : "instanceIdentifier",
    "maxConcurrentTasks" : 4,
    "statelessFlowTimeout" : "statelessFlowTimeout",
    "groupIdentifier" : "groupIdentifier",
    "remoteProcessGroups" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "proxyPassword" : "proxyPassword",
      "communicationsTimeout" : "communicationsTimeout",
      "proxyHost" : "proxyHost",
      "proxyPort" : 7,
      "outputPorts" : [ null, null ],
      "transportProtocol" : "transportProtocol",
      "name" : "name",
      "proxyUser" : "proxyUser",
      "inputPorts" : [ {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      }, {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      } ],
      "targetUris" : "targetUris",
      "instanceIdentifier" : "instanceIdentifier",
      "yieldDuration" : "yieldDuration",
      "groupIdentifier" : "groupIdentifier",
      "localNetworkInterface" : "localNetworkInterface"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "proxyPassword" : "proxyPassword",
      "communicationsTimeout" : "communicationsTimeout",
      "proxyHost" : "proxyHost",
      "proxyPort" : 7,
      "outputPorts" : [ null, null ],
      "transportProtocol" : "transportProtocol",
      "name" : "name",
      "proxyUser" : "proxyUser",
      "inputPorts" : [ {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      }, {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      } ],
      "targetUris" : "targetUris",
      "instanceIdentifier" : "instanceIdentifier",
      "yieldDuration" : "yieldDuration",
      "groupIdentifier" : "groupIdentifier",
      "localNetworkInterface" : "localNetworkInterface"
    } ]
  },
  "parameterProviders" : {
    "key" : {
      "identifier" : "identifier",
      "name" : "name",
      "type" : "type"
    }
  },
  "flow" : {
    "versionCount" : 0,
    "bucketName" : "bucketName",
    "identifier" : "identifier",
    "permissions" : {
      "canRead" : true,
      "canDelete" : true,
      "canWrite" : true
    },
    "createdTimestamp" : 1,
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "name" : "name",
    "description" : "description",
    "modifiedTimestamp" : 1,
    "bucketIdentifier" : "bucketIdentifier",
    "type" : "Flow",
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 6
    }
  },
  "flowEncodingVersion" : "flowEncodingVersion",
  "latest" : true,
  "parameterContexts" : {
    "key" : {
      "parameterGroupName" : "parameterGroupName",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "synchronized" : true,
      "comments" : "comments",
      "description" : "description",
      "inheritedParameterContexts" : [ "inheritedParameterContexts", "inheritedParameterContexts" ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "parameterProvider" : "parameterProvider",
      "parameters" : [ {
        "referencedAssets" : [ {
          "identifier" : "identifier",
          "name" : "name"
        }, {
          "identifier" : "identifier",
          "name" : "name"
        } ],
        "provided" : true,
        "name" : "name",
        "description" : "description",
        "sensitive" : true,
        "value" : "value"
      }, {
        "referencedAssets" : [ {
          "identifier" : "identifier",
          "name" : "name"
        }, {
          "identifier" : "identifier",
          "name" : "name"
        } ],
        "provided" : true,
        "name" : "name",
        "description" : "description",
        "sensitive" : true,
        "value" : "value"
      } ]
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

VersionedFlowSnapshot

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
delete /buckets/{bucketId}/flows/{flowId}
Delete bucket flow (deleteFlow)
Deletes a flow, including all saved versions of that flow.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier
flowId (required)
Path Parameter — The flow identifier

Query parameters

version (required)
Query Parameter — The version is used to verify the client is working with the latest version of the entity.
clientId (optional)
Query Parameter — If the client id is not specified, new one will be generated. This value (whether specified or generated) is included in the response.

Return type

VersionedFlow

Example data

Content-Type: application/json
{
  "versionCount" : 0,
  "bucketName" : "bucketName",
  "identifier" : "identifier",
  "permissions" : {
    "canRead" : true,
    "canDelete" : true,
    "canWrite" : true
  },
  "createdTimestamp" : 1,
  "link" : {
    "rel" : "rel",
    "params" : {
      "key" : "params"
    },
    "title" : "title",
    "type" : "type",
    "uri" : "http://example.com/aeiou",
    "uriBuilder" : { },
    "rels" : [ "rels", "rels" ]
  },
  "name" : "name",
  "description" : "description",
  "modifiedTimestamp" : 1,
  "bucketIdentifier" : "bucketIdentifier",
  "type" : "Flow",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 6
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

VersionedFlow

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
get /buckets/{bucketId}/flows/{flowId}/versions/{versionNumber}/export
Exports specified bucket flow version content (exportVersionedFlow)
Exports the specified version of a flow, including the metadata and content of the flow.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier
flowId (required)
Path Parameter — The flow identifier
versionNumber (required)
Path Parameter — The version number format: int32

Return type

VersionedFlowSnapshot

Example data

Content-Type: application/json
{
  "bucket" : {
    "identifier" : "identifier",
    "allowBundleRedeploy" : true,
    "permissions" : {
      "canRead" : true,
      "canDelete" : true,
      "canWrite" : true
    },
    "createdTimestamp" : 1,
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "name" : "name",
    "description" : "description",
    "allowPublicRead" : true,
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 6
    }
  },
  "externalControllerServices" : {
    "key" : {
      "identifier" : "identifier",
      "name" : "name"
    }
  },
  "snapshotMetadata" : {
    "flowIdentifier" : "flowIdentifier",
    "comments" : "comments",
    "author" : "author",
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "bucketIdentifier" : "bucketIdentifier",
    "version" : 0,
    "timestamp" : 1
  },
  "flowContents" : {
    "processors" : [ {
      "autoTerminatedRelationships" : [ "autoTerminatedRelationships", "autoTerminatedRelationships" ],
      "bulletinLevel" : "bulletinLevel",
      "executionNode" : "executionNode",
      "runDurationMillis" : 1,
      "propertyDescriptors" : { },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "maxBackoffPeriod" : "maxBackoffPeriod",
      "yieldDuration" : "yieldDuration",
      "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "concurrentlySchedulableTaskCount" : 7,
      "retryCount" : 1,
      "penaltyDuration" : "penaltyDuration",
      "backoffMechanism" : "backoffMechanism",
      "schedulingStrategy" : "schedulingStrategy",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "schedulingPeriod" : "schedulingPeriod",
      "style" : {
        "key" : "style"
      },
      "groupIdentifier" : "groupIdentifier",
      "properties" : {
        "key" : "properties"
      }
    }, {
      "autoTerminatedRelationships" : [ "autoTerminatedRelationships", "autoTerminatedRelationships" ],
      "bulletinLevel" : "bulletinLevel",
      "executionNode" : "executionNode",
      "runDurationMillis" : 1,
      "propertyDescriptors" : { },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "maxBackoffPeriod" : "maxBackoffPeriod",
      "yieldDuration" : "yieldDuration",
      "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "concurrentlySchedulableTaskCount" : 7,
      "retryCount" : 1,
      "penaltyDuration" : "penaltyDuration",
      "backoffMechanism" : "backoffMechanism",
      "schedulingStrategy" : "schedulingStrategy",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "schedulingPeriod" : "schedulingPeriod",
      "style" : {
        "key" : "style"
      },
      "groupIdentifier" : "groupIdentifier",
      "properties" : {
        "key" : "properties"
      }
    } ],
    "scheduledState" : "ENABLED",
    "processGroups" : [ null, null ],
    "outputPorts" : [ null, null ],
    "funnels" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier"
    } ],
    "versionedFlowCoordinates" : {
      "registryId" : "registryId",
      "storageLocation" : "storageLocation",
      "bucketId" : "bucketId",
      "branch" : "branch",
      "flowId" : "flowId",
      "version" : "version",
      "latest" : true
    },
    "connections" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "prioritizers" : [ "prioritizers", "prioritizers" ],
      "comments" : "comments",
      "flowFileExpiration" : "flowFileExpiration",
      "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
      "loadBalanceCompression" : "loadBalanceCompression",
      "destination" : {
        "comments" : "comments",
        "groupId" : "groupId",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "id" : "id",
        "type" : "PROCESSOR"
      },
      "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
      "loadBalanceStrategy" : "loadBalanceStrategy",
      "labelIndex" : 5,
      "bends" : [ {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      }, {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      } ],
      "backPressureObjectThreshold" : 0,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "partitioningAttribute" : "partitioningAttribute",
      "zIndex" : 5
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "prioritizers" : [ "prioritizers", "prioritizers" ],
      "comments" : "comments",
      "flowFileExpiration" : "flowFileExpiration",
      "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
      "loadBalanceCompression" : "loadBalanceCompression",
      "destination" : {
        "comments" : "comments",
        "groupId" : "groupId",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "id" : "id",
        "type" : "PROCESSOR"
      },
      "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
      "loadBalanceStrategy" : "loadBalanceStrategy",
      "labelIndex" : 5,
      "bends" : [ {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      }, {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      } ],
      "backPressureObjectThreshold" : 0,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "partitioningAttribute" : "partitioningAttribute",
      "zIndex" : 5
    } ],
    "logFileSuffix" : "logFileSuffix",
    "parameterContextName" : "parameterContextName",
    "componentType" : "CONNECTION",
    "identifier" : "identifier",
    "defaultBackPressureObjectThreshold" : 2,
    "comments" : "comments",
    "executionEngine" : "STANDARD",
    "defaultBackPressureDataSizeThreshold" : "defaultBackPressureDataSizeThreshold",
    "labels" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "width" : 3.616076749251911,
      "instanceIdentifier" : "instanceIdentifier",
      "style" : {
        "key" : "style"
      },
      "label" : "label",
      "groupIdentifier" : "groupIdentifier",
      "height" : 9.301444243932576,
      "zIndex" : 2
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "width" : 3.616076749251911,
      "instanceIdentifier" : "instanceIdentifier",
      "style" : {
        "key" : "style"
      },
      "label" : "label",
      "groupIdentifier" : "groupIdentifier",
      "height" : 9.301444243932576,
      "zIndex" : 2
    } ],
    "controllerServices" : [ {
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "bulletinLevel" : "bulletinLevel",
      "propertyDescriptors" : {
        "key" : {
          "resourceDefinition" : {
            "resourceTypes" : [ "FILE", "FILE" ],
            "cardinality" : "SINGLE"
          },
          "displayName" : "displayName",
          "identifiesControllerService" : true,
          "name" : "name",
          "dynamic" : true,
          "sensitive" : true,
          "listenPortDefinition" : {
            "applicationProtocols" : [ "applicationProtocols", "applicationProtocols" ],
            "transportProtocol" : "TCP"
          }
        }
      },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "componentState" : {
        "localNodeStates" : [ {
          "state" : {
            "key" : "state"
          }
        }, {
          "state" : {
            "key" : "state"
          }
        } ],
        "clusterState" : {
          "key" : "clusterState"
        }
      },
      "controllerServiceApis" : [ {
        "type" : "type"
      }, {
        "type" : "type"
      } ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "properties" : {
        "key" : "properties"
      }
    }, {
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "bulletinLevel" : "bulletinLevel",
      "propertyDescriptors" : {
        "key" : {
          "resourceDefinition" : {
            "resourceTypes" : [ "FILE", "FILE" ],
            "cardinality" : "SINGLE"
          },
          "displayName" : "displayName",
          "identifiesControllerService" : true,
          "name" : "name",
          "dynamic" : true,
          "sensitive" : true,
          "listenPortDefinition" : {
            "applicationProtocols" : [ "applicationProtocols", "applicationProtocols" ],
            "transportProtocol" : "TCP"
          }
        }
      },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "componentState" : {
        "localNodeStates" : [ {
          "state" : {
            "key" : "state"
          }
        }, {
          "state" : {
            "key" : "state"
          }
        } ],
        "clusterState" : {
          "key" : "clusterState"
        }
      },
      "controllerServiceApis" : [ {
        "type" : "type"
      }, {
        "type" : "type"
      } ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "properties" : {
        "key" : "properties"
      }
    } ],
    "defaultFlowFileExpiration" : "defaultFlowFileExpiration",
    "flowFileConcurrency" : "flowFileConcurrency",
    "flowFileOutboundPolicy" : "flowFileOutboundPolicy",
    "name" : "name",
    "inputPorts" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "allowRemoteAccess" : true,
      "concurrentlySchedulableTaskCount" : 7,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "portFunction" : "STANDARD",
      "groupIdentifier" : "groupIdentifier",
      "type" : "INPUT_PORT",
      "scheduledState" : "ENABLED"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "allowRemoteAccess" : true,
      "concurrentlySchedulableTaskCount" : 7,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "portFunction" : "STANDARD",
      "groupIdentifier" : "groupIdentifier",
      "type" : "INPUT_PORT",
      "scheduledState" : "ENABLED"
    } ],
    "instanceIdentifier" : "instanceIdentifier",
    "maxConcurrentTasks" : 4,
    "statelessFlowTimeout" : "statelessFlowTimeout",
    "groupIdentifier" : "groupIdentifier",
    "remoteProcessGroups" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "proxyPassword" : "proxyPassword",
      "communicationsTimeout" : "communicationsTimeout",
      "proxyHost" : "proxyHost",
      "proxyPort" : 7,
      "outputPorts" : [ null, null ],
      "transportProtocol" : "transportProtocol",
      "name" : "name",
      "proxyUser" : "proxyUser",
      "inputPorts" : [ {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      }, {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      } ],
      "targetUris" : "targetUris",
      "instanceIdentifier" : "instanceIdentifier",
      "yieldDuration" : "yieldDuration",
      "groupIdentifier" : "groupIdentifier",
      "localNetworkInterface" : "localNetworkInterface"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "proxyPassword" : "proxyPassword",
      "communicationsTimeout" : "communicationsTimeout",
      "proxyHost" : "proxyHost",
      "proxyPort" : 7,
      "outputPorts" : [ null, null ],
      "transportProtocol" : "transportProtocol",
      "name" : "name",
      "proxyUser" : "proxyUser",
      "inputPorts" : [ {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      }, {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      } ],
      "targetUris" : "targetUris",
      "instanceIdentifier" : "instanceIdentifier",
      "yieldDuration" : "yieldDuration",
      "groupIdentifier" : "groupIdentifier",
      "localNetworkInterface" : "localNetworkInterface"
    } ]
  },
  "parameterProviders" : {
    "key" : {
      "identifier" : "identifier",
      "name" : "name",
      "type" : "type"
    }
  },
  "flow" : {
    "versionCount" : 0,
    "bucketName" : "bucketName",
    "identifier" : "identifier",
    "permissions" : {
      "canRead" : true,
      "canDelete" : true,
      "canWrite" : true
    },
    "createdTimestamp" : 1,
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "name" : "name",
    "description" : "description",
    "modifiedTimestamp" : 1,
    "bucketIdentifier" : "bucketIdentifier",
    "type" : "Flow",
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 6
    }
  },
  "flowEncodingVersion" : "flowEncodingVersion",
  "latest" : true,
  "parameterContexts" : {
    "key" : {
      "parameterGroupName" : "parameterGroupName",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "synchronized" : true,
      "comments" : "comments",
      "description" : "description",
      "inheritedParameterContexts" : [ "inheritedParameterContexts", "inheritedParameterContexts" ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "parameterProvider" : "parameterProvider",
      "parameters" : [ {
        "referencedAssets" : [ {
          "identifier" : "identifier",
          "name" : "name"
        }, {
          "identifier" : "identifier",
          "name" : "name"
        } ],
        "provided" : true,
        "name" : "name",
        "description" : "description",
        "sensitive" : true,
        "value" : "value"
      }, {
        "referencedAssets" : [ {
          "identifier" : "identifier",
          "name" : "name"
        }, {
          "identifier" : "identifier",
          "name" : "name"
        } ],
        "provided" : true,
        "name" : "name",
        "description" : "description",
        "sensitive" : true,
        "value" : "value"
      } ]
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

VersionedFlowSnapshot

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
get /buckets/{bucketId}/flows/{flowId}
Get bucket flow (getFlow)
Retrieves the flow with the given id in the given bucket.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier
flowId (required)
Path Parameter — The flow identifier

Return type

VersionedFlow

Example data

Content-Type: application/json
{
  "versionCount" : 0,
  "bucketName" : "bucketName",
  "identifier" : "identifier",
  "permissions" : {
    "canRead" : true,
    "canDelete" : true,
    "canWrite" : true
  },
  "createdTimestamp" : 1,
  "link" : {
    "rel" : "rel",
    "params" : {
      "key" : "params"
    },
    "title" : "title",
    "type" : "type",
    "uri" : "http://example.com/aeiou",
    "uriBuilder" : { },
    "rels" : [ "rels", "rels" ]
  },
  "name" : "name",
  "description" : "description",
  "modifiedTimestamp" : 1,
  "bucketIdentifier" : "bucketIdentifier",
  "type" : "Flow",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 6
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

VersionedFlow

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
get /buckets/{bucketId}/flows/{flowId}/diff/{versionA}/{versionB}
Get bucket flow diff (getFlowDiff)
Computes the differences between two given versions of a flow.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier
flowId (required)
Path Parameter — The flow identifier
versionA (required)
Path Parameter — The first version number format: int32
versionB (required)
Path Parameter — The second version number format: int32

Return type

VersionedFlowDifference

Example data

Content-Type: application/json
{
  "versionB" : 6,
  "versionA" : 0,
  "bucketId" : "bucketId",
  "componentDifferenceGroups" : [ {
    "componentType" : "componentType",
    "componentId" : "componentId",
    "processGroupId" : "processGroupId",
    "differences" : [ {
      "differenceType" : "differenceType",
      "differenceTypeDescription" : "differenceTypeDescription",
      "changeDescription" : "changeDescription",
      "valueB" : "valueB",
      "valueA" : "valueA"
    }, {
      "differenceType" : "differenceType",
      "differenceTypeDescription" : "differenceTypeDescription",
      "changeDescription" : "changeDescription",
      "valueB" : "valueB",
      "valueA" : "valueA"
    } ],
    "componentName" : "componentName"
  }, {
    "componentType" : "componentType",
    "componentId" : "componentId",
    "processGroupId" : "processGroupId",
    "differences" : [ {
      "differenceType" : "differenceType",
      "differenceTypeDescription" : "differenceTypeDescription",
      "changeDescription" : "changeDescription",
      "valueB" : "valueB",
      "valueA" : "valueA"
    }, {
      "differenceType" : "differenceType",
      "differenceTypeDescription" : "differenceTypeDescription",
      "changeDescription" : "changeDescription",
      "valueB" : "valueB",
      "valueA" : "valueA"
    } ],
    "componentName" : "componentName"
  } ],
  "flowId" : "flowId"
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

VersionedFlowDifference

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
get /buckets/{bucketId}/flows/{flowId}/versions/{versionNumber}
Get bucket flow version (getFlowVersion)
Gets the given version of a flow, including the metadata and content for the version.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier
flowId (required)
Path Parameter — The flow identifier
versionNumber (required)
Path Parameter — The version number format: int32

Return type

VersionedFlowSnapshot

Example data

Content-Type: application/json
{
  "bucket" : {
    "identifier" : "identifier",
    "allowBundleRedeploy" : true,
    "permissions" : {
      "canRead" : true,
      "canDelete" : true,
      "canWrite" : true
    },
    "createdTimestamp" : 1,
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "name" : "name",
    "description" : "description",
    "allowPublicRead" : true,
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 6
    }
  },
  "externalControllerServices" : {
    "key" : {
      "identifier" : "identifier",
      "name" : "name"
    }
  },
  "snapshotMetadata" : {
    "flowIdentifier" : "flowIdentifier",
    "comments" : "comments",
    "author" : "author",
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "bucketIdentifier" : "bucketIdentifier",
    "version" : 0,
    "timestamp" : 1
  },
  "flowContents" : {
    "processors" : [ {
      "autoTerminatedRelationships" : [ "autoTerminatedRelationships", "autoTerminatedRelationships" ],
      "bulletinLevel" : "bulletinLevel",
      "executionNode" : "executionNode",
      "runDurationMillis" : 1,
      "propertyDescriptors" : { },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "maxBackoffPeriod" : "maxBackoffPeriod",
      "yieldDuration" : "yieldDuration",
      "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "concurrentlySchedulableTaskCount" : 7,
      "retryCount" : 1,
      "penaltyDuration" : "penaltyDuration",
      "backoffMechanism" : "backoffMechanism",
      "schedulingStrategy" : "schedulingStrategy",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "schedulingPeriod" : "schedulingPeriod",
      "style" : {
        "key" : "style"
      },
      "groupIdentifier" : "groupIdentifier",
      "properties" : {
        "key" : "properties"
      }
    }, {
      "autoTerminatedRelationships" : [ "autoTerminatedRelationships", "autoTerminatedRelationships" ],
      "bulletinLevel" : "bulletinLevel",
      "executionNode" : "executionNode",
      "runDurationMillis" : 1,
      "propertyDescriptors" : { },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "maxBackoffPeriod" : "maxBackoffPeriod",
      "yieldDuration" : "yieldDuration",
      "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "concurrentlySchedulableTaskCount" : 7,
      "retryCount" : 1,
      "penaltyDuration" : "penaltyDuration",
      "backoffMechanism" : "backoffMechanism",
      "schedulingStrategy" : "schedulingStrategy",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "schedulingPeriod" : "schedulingPeriod",
      "style" : {
        "key" : "style"
      },
      "groupIdentifier" : "groupIdentifier",
      "properties" : {
        "key" : "properties"
      }
    } ],
    "scheduledState" : "ENABLED",
    "processGroups" : [ null, null ],
    "outputPorts" : [ null, null ],
    "funnels" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier"
    } ],
    "versionedFlowCoordinates" : {
      "registryId" : "registryId",
      "storageLocation" : "storageLocation",
      "bucketId" : "bucketId",
      "branch" : "branch",
      "flowId" : "flowId",
      "version" : "version",
      "latest" : true
    },
    "connections" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "prioritizers" : [ "prioritizers", "prioritizers" ],
      "comments" : "comments",
      "flowFileExpiration" : "flowFileExpiration",
      "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
      "loadBalanceCompression" : "loadBalanceCompression",
      "destination" : {
        "comments" : "comments",
        "groupId" : "groupId",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "id" : "id",
        "type" : "PROCESSOR"
      },
      "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
      "loadBalanceStrategy" : "loadBalanceStrategy",
      "labelIndex" : 5,
      "bends" : [ {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      }, {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      } ],
      "backPressureObjectThreshold" : 0,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "partitioningAttribute" : "partitioningAttribute",
      "zIndex" : 5
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "prioritizers" : [ "prioritizers", "prioritizers" ],
      "comments" : "comments",
      "flowFileExpiration" : "flowFileExpiration",
      "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
      "loadBalanceCompression" : "loadBalanceCompression",
      "destination" : {
        "comments" : "comments",
        "groupId" : "groupId",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "id" : "id",
        "type" : "PROCESSOR"
      },
      "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
      "loadBalanceStrategy" : "loadBalanceStrategy",
      "labelIndex" : 5,
      "bends" : [ {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      }, {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      } ],
      "backPressureObjectThreshold" : 0,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "partitioningAttribute" : "partitioningAttribute",
      "zIndex" : 5
    } ],
    "logFileSuffix" : "logFileSuffix",
    "parameterContextName" : "parameterContextName",
    "componentType" : "CONNECTION",
    "identifier" : "identifier",
    "defaultBackPressureObjectThreshold" : 2,
    "comments" : "comments",
    "executionEngine" : "STANDARD",
    "defaultBackPressureDataSizeThreshold" : "defaultBackPressureDataSizeThreshold",
    "labels" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "width" : 3.616076749251911,
      "instanceIdentifier" : "instanceIdentifier",
      "style" : {
        "key" : "style"
      },
      "label" : "label",
      "groupIdentifier" : "groupIdentifier",
      "height" : 9.301444243932576,
      "zIndex" : 2
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "width" : 3.616076749251911,
      "instanceIdentifier" : "instanceIdentifier",
      "style" : {
        "key" : "style"
      },
      "label" : "label",
      "groupIdentifier" : "groupIdentifier",
      "height" : 9.301444243932576,
      "zIndex" : 2
    } ],
    "controllerServices" : [ {
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "bulletinLevel" : "bulletinLevel",
      "propertyDescriptors" : {
        "key" : {
          "resourceDefinition" : {
            "resourceTypes" : [ "FILE", "FILE" ],
            "cardinality" : "SINGLE"
          },
          "displayName" : "displayName",
          "identifiesControllerService" : true,
          "name" : "name",
          "dynamic" : true,
          "sensitive" : true,
          "listenPortDefinition" : {
            "applicationProtocols" : [ "applicationProtocols", "applicationProtocols" ],
            "transportProtocol" : "TCP"
          }
        }
      },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "componentState" : {
        "localNodeStates" : [ {
          "state" : {
            "key" : "state"
          }
        }, {
          "state" : {
            "key" : "state"
          }
        } ],
        "clusterState" : {
          "key" : "clusterState"
        }
      },
      "controllerServiceApis" : [ {
        "type" : "type"
      }, {
        "type" : "type"
      } ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "properties" : {
        "key" : "properties"
      }
    }, {
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "bulletinLevel" : "bulletinLevel",
      "propertyDescriptors" : {
        "key" : {
          "resourceDefinition" : {
            "resourceTypes" : [ "FILE", "FILE" ],
            "cardinality" : "SINGLE"
          },
          "displayName" : "displayName",
          "identifiesControllerService" : true,
          "name" : "name",
          "dynamic" : true,
          "sensitive" : true,
          "listenPortDefinition" : {
            "applicationProtocols" : [ "applicationProtocols", "applicationProtocols" ],
            "transportProtocol" : "TCP"
          }
        }
      },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "componentState" : {
        "localNodeStates" : [ {
          "state" : {
            "key" : "state"
          }
        }, {
          "state" : {
            "key" : "state"
          }
        } ],
        "clusterState" : {
          "key" : "clusterState"
        }
      },
      "controllerServiceApis" : [ {
        "type" : "type"
      }, {
        "type" : "type"
      } ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "properties" : {
        "key" : "properties"
      }
    } ],
    "defaultFlowFileExpiration" : "defaultFlowFileExpiration",
    "flowFileConcurrency" : "flowFileConcurrency",
    "flowFileOutboundPolicy" : "flowFileOutboundPolicy",
    "name" : "name",
    "inputPorts" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "allowRemoteAccess" : true,
      "concurrentlySchedulableTaskCount" : 7,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "portFunction" : "STANDARD",
      "groupIdentifier" : "groupIdentifier",
      "type" : "INPUT_PORT",
      "scheduledState" : "ENABLED"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "allowRemoteAccess" : true,
      "concurrentlySchedulableTaskCount" : 7,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "portFunction" : "STANDARD",
      "groupIdentifier" : "groupIdentifier",
      "type" : "INPUT_PORT",
      "scheduledState" : "ENABLED"
    } ],
    "instanceIdentifier" : "instanceIdentifier",
    "maxConcurrentTasks" : 4,
    "statelessFlowTimeout" : "statelessFlowTimeout",
    "groupIdentifier" : "groupIdentifier",
    "remoteProcessGroups" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "proxyPassword" : "proxyPassword",
      "communicationsTimeout" : "communicationsTimeout",
      "proxyHost" : "proxyHost",
      "proxyPort" : 7,
      "outputPorts" : [ null, null ],
      "transportProtocol" : "transportProtocol",
      "name" : "name",
      "proxyUser" : "proxyUser",
      "inputPorts" : [ {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      }, {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      } ],
      "targetUris" : "targetUris",
      "instanceIdentifier" : "instanceIdentifier",
      "yieldDuration" : "yieldDuration",
      "groupIdentifier" : "groupIdentifier",
      "localNetworkInterface" : "localNetworkInterface"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "proxyPassword" : "proxyPassword",
      "communicationsTimeout" : "communicationsTimeout",
      "proxyHost" : "proxyHost",
      "proxyPort" : 7,
      "outputPorts" : [ null, null ],
      "transportProtocol" : "transportProtocol",
      "name" : "name",
      "proxyUser" : "proxyUser",
      "inputPorts" : [ {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      }, {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      } ],
      "targetUris" : "targetUris",
      "instanceIdentifier" : "instanceIdentifier",
      "yieldDuration" : "yieldDuration",
      "groupIdentifier" : "groupIdentifier",
      "localNetworkInterface" : "localNetworkInterface"
    } ]
  },
  "parameterProviders" : {
    "key" : {
      "identifier" : "identifier",
      "name" : "name",
      "type" : "type"
    }
  },
  "flow" : {
    "versionCount" : 0,
    "bucketName" : "bucketName",
    "identifier" : "identifier",
    "permissions" : {
      "canRead" : true,
      "canDelete" : true,
      "canWrite" : true
    },
    "createdTimestamp" : 1,
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "name" : "name",
    "description" : "description",
    "modifiedTimestamp" : 1,
    "bucketIdentifier" : "bucketIdentifier",
    "type" : "Flow",
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 6
    }
  },
  "flowEncodingVersion" : "flowEncodingVersion",
  "latest" : true,
  "parameterContexts" : {
    "key" : {
      "parameterGroupName" : "parameterGroupName",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "synchronized" : true,
      "comments" : "comments",
      "description" : "description",
      "inheritedParameterContexts" : [ "inheritedParameterContexts", "inheritedParameterContexts" ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "parameterProvider" : "parameterProvider",
      "parameters" : [ {
        "referencedAssets" : [ {
          "identifier" : "identifier",
          "name" : "name"
        }, {
          "identifier" : "identifier",
          "name" : "name"
        } ],
        "provided" : true,
        "name" : "name",
        "description" : "description",
        "sensitive" : true,
        "value" : "value"
      }, {
        "referencedAssets" : [ {
          "identifier" : "identifier",
          "name" : "name"
        }, {
          "identifier" : "identifier",
          "name" : "name"
        } ],
        "provided" : true,
        "name" : "name",
        "description" : "description",
        "sensitive" : true,
        "value" : "value"
      } ]
    }
  }
}

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

VersionedFlowSnapshot

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
get /buckets/{bucketId}/flows/{flowId}/versions
Get bucket flow versions (getFlowVersions)
Gets summary information for all versions of a flow. Versions are ordered newest->oldest.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier
flowId (required)
Path Parameter — The flow identifier

Return type

array[VersionedFlowSnapshotMetadata]

Example data

Content-Type: application/json
[ {
  "flowIdentifier" : "flowIdentifier",
  "comments" : "comments",
  "author" : "author",
  "link" : {
    "rel" : "rel",
    "params" : {
      "key" : "params"
    },
    "title" : "title",
    "type" : "type",
    "uri" : "http://example.com/aeiou",
    "uriBuilder" : { },
    "rels" : [ "rels", "rels" ]
  },
  "bucketIdentifier" : "bucketIdentifier",
  "version" : 0,
  "timestamp" : 1
}, {
  "flowIdentifier" : "flowIdentifier",
  "comments" : "comments",
  "author" : "author",
  "link" : {
    "rel" : "rel",
    "params" : {
      "key" : "params"
    },
    "title" : "title",
    "type" : "type",
    "uri" : "http://example.com/aeiou",
    "uriBuilder" : { },
    "rels" : [ "rels", "rels" ]
  },
  "bucketIdentifier" : "bucketIdentifier",
  "version" : 0,
  "timestamp" : 1
} ]

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
get /buckets/{bucketId}/flows
Get bucket flows (getFlows)
Retrieves all flows in the given bucket.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier

Return type

array[VersionedFlow]

Example data

Content-Type: application/json
[ {
  "versionCount" : 0,
  "bucketName" : "bucketName",
  "identifier" : "identifier",
  "permissions" : {
    "canRead" : true,
    "canDelete" : true,
    "canWrite" : true
  },
  "createdTimestamp" : 1,
  "link" : {
    "rel" : "rel",
    "params" : {
      "key" : "params"
    },
    "title" : "title",
    "type" : "type",
    "uri" : "http://example.com/aeiou",
    "uriBuilder" : { },
    "rels" : [ "rels", "rels" ]
  },
  "name" : "name",
  "description" : "description",
  "modifiedTimestamp" : 1,
  "bucketIdentifier" : "bucketIdentifier",
  "type" : "Flow",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 6
  }
}, {
  "versionCount" : 0,
  "bucketName" : "bucketName",
  "identifier" : "identifier",
  "permissions" : {
    "canRead" : true,
    "canDelete" : true,
    "canWrite" : true
  },
  "createdTimestamp" : 1,
  "link" : {
    "rel" : "rel",
    "params" : {
      "key" : "params"
    },
    "title" : "title",
    "type" : "type",
    "uri" : "http://example.com/aeiou",
    "uriBuilder" : { },
    "rels" : [ "rels", "rels" ]
  },
  "name" : "name",
  "description" : "description",
  "modifiedTimestamp" : 1,
  "bucketIdentifier" : "bucketIdentifier",
  "type" : "Flow",
  "revision" : {
    "clientId" : "clientId",
    "lastModifier" : "lastModifier",
    "version" : 6
  }
} ]

Produces

This API call produces the following media types according to the Accept request header; the media type will be conveyed by the Content-Type response header.

Responses

200

400

NiFi Registry was unable to complete the request because it was invalid. The request should not be retried without modification.

401

Client could not be authenticated.

403

Client is not authorized to make this request.

404

The specified resource could not be found.

409

NiFi Registry was unable to complete the request because it assumes a server state that is not valid.

Up
get /buckets/{bucketId}/flows/{flowId}/versions/latest
Get latest bucket flow version content (getLatestFlowVersion)
Gets the latest version of a flow, including the metadata and content of the flow.

Path parameters

bucketId (required)
Path Parameter — The bucket identifier
flowId (required)
Path Parameter — The flow identifier

Return type

VersionedFlowSnapshot

Example data

Content-Type: application/json
{
  "bucket" : {
    "identifier" : "identifier",
    "allowBundleRedeploy" : true,
    "permissions" : {
      "canRead" : true,
      "canDelete" : true,
      "canWrite" : true
    },
    "createdTimestamp" : 1,
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "name" : "name",
    "description" : "description",
    "allowPublicRead" : true,
    "revision" : {
      "clientId" : "clientId",
      "lastModifier" : "lastModifier",
      "version" : 6
    }
  },
  "externalControllerServices" : {
    "key" : {
      "identifier" : "identifier",
      "name" : "name"
    }
  },
  "snapshotMetadata" : {
    "flowIdentifier" : "flowIdentifier",
    "comments" : "comments",
    "author" : "author",
    "link" : {
      "rel" : "rel",
      "params" : {
        "key" : "params"
      },
      "title" : "title",
      "type" : "type",
      "uri" : "http://example.com/aeiou",
      "uriBuilder" : { },
      "rels" : [ "rels", "rels" ]
    },
    "bucketIdentifier" : "bucketIdentifier",
    "version" : 0,
    "timestamp" : 1
  },
  "flowContents" : {
    "processors" : [ {
      "autoTerminatedRelationships" : [ "autoTerminatedRelationships", "autoTerminatedRelationships" ],
      "bulletinLevel" : "bulletinLevel",
      "executionNode" : "executionNode",
      "runDurationMillis" : 1,
      "propertyDescriptors" : { },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "maxBackoffPeriod" : "maxBackoffPeriod",
      "yieldDuration" : "yieldDuration",
      "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "concurrentlySchedulableTaskCount" : 7,
      "retryCount" : 1,
      "penaltyDuration" : "penaltyDuration",
      "backoffMechanism" : "backoffMechanism",
      "schedulingStrategy" : "schedulingStrategy",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "schedulingPeriod" : "schedulingPeriod",
      "style" : {
        "key" : "style"
      },
      "groupIdentifier" : "groupIdentifier",
      "properties" : {
        "key" : "properties"
      }
    }, {
      "autoTerminatedRelationships" : [ "autoTerminatedRelationships", "autoTerminatedRelationships" ],
      "bulletinLevel" : "bulletinLevel",
      "executionNode" : "executionNode",
      "runDurationMillis" : 1,
      "propertyDescriptors" : { },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "maxBackoffPeriod" : "maxBackoffPeriod",
      "yieldDuration" : "yieldDuration",
      "retriedRelationships" : [ "retriedRelationships", "retriedRelationships" ],
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "concurrentlySchedulableTaskCount" : 7,
      "retryCount" : 1,
      "penaltyDuration" : "penaltyDuration",
      "backoffMechanism" : "backoffMechanism",
      "schedulingStrategy" : "schedulingStrategy",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "schedulingPeriod" : "schedulingPeriod",
      "style" : {
        "key" : "style"
      },
      "groupIdentifier" : "groupIdentifier",
      "properties" : {
        "key" : "properties"
      }
    } ],
    "scheduledState" : "ENABLED",
    "processGroups" : [ null, null ],
    "outputPorts" : [ null, null ],
    "funnels" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier"
    } ],
    "versionedFlowCoordinates" : {
      "registryId" : "registryId",
      "storageLocation" : "storageLocation",
      "bucketId" : "bucketId",
      "branch" : "branch",
      "flowId" : "flowId",
      "version" : "version",
      "latest" : true
    },
    "connections" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "prioritizers" : [ "prioritizers", "prioritizers" ],
      "comments" : "comments",
      "flowFileExpiration" : "flowFileExpiration",
      "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
      "loadBalanceCompression" : "loadBalanceCompression",
      "destination" : {
        "comments" : "comments",
        "groupId" : "groupId",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "id" : "id",
        "type" : "PROCESSOR"
      },
      "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
      "loadBalanceStrategy" : "loadBalanceStrategy",
      "labelIndex" : 5,
      "bends" : [ {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      }, {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      } ],
      "backPressureObjectThreshold" : 0,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "partitioningAttribute" : "partitioningAttribute",
      "zIndex" : 5
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "prioritizers" : [ "prioritizers", "prioritizers" ],
      "comments" : "comments",
      "flowFileExpiration" : "flowFileExpiration",
      "selectedRelationships" : [ "selectedRelationships", "selectedRelationships" ],
      "loadBalanceCompression" : "loadBalanceCompression",
      "destination" : {
        "comments" : "comments",
        "groupId" : "groupId",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "id" : "id",
        "type" : "PROCESSOR"
      },
      "backPressureDataSizeThreshold" : "backPressureDataSizeThreshold",
      "loadBalanceStrategy" : "loadBalanceStrategy",
      "labelIndex" : 5,
      "bends" : [ {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      }, {
        "x" : 6.027456183070403,
        "y" : 1.4658129805029452
      } ],
      "backPressureObjectThreshold" : 0,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "partitioningAttribute" : "partitioningAttribute",
      "zIndex" : 5
    } ],
    "logFileSuffix" : "logFileSuffix",
    "parameterContextName" : "parameterContextName",
    "componentType" : "CONNECTION",
    "identifier" : "identifier",
    "defaultBackPressureObjectThreshold" : 2,
    "comments" : "comments",
    "executionEngine" : "STANDARD",
    "defaultBackPressureDataSizeThreshold" : "defaultBackPressureDataSizeThreshold",
    "labels" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "width" : 3.616076749251911,
      "instanceIdentifier" : "instanceIdentifier",
      "style" : {
        "key" : "style"
      },
      "label" : "label",
      "groupIdentifier" : "groupIdentifier",
      "height" : 9.301444243932576,
      "zIndex" : 2
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "name" : "name",
      "width" : 3.616076749251911,
      "instanceIdentifier" : "instanceIdentifier",
      "style" : {
        "key" : "style"
      },
      "label" : "label",
      "groupIdentifier" : "groupIdentifier",
      "height" : 9.301444243932576,
      "zIndex" : 2
    } ],
    "controllerServices" : [ {
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "bulletinLevel" : "bulletinLevel",
      "propertyDescriptors" : {
        "key" : {
          "resourceDefinition" : {
            "resourceTypes" : [ "FILE", "FILE" ],
            "cardinality" : "SINGLE"
          },
          "displayName" : "displayName",
          "identifiesControllerService" : true,
          "name" : "name",
          "dynamic" : true,
          "sensitive" : true,
          "listenPortDefinition" : {
            "applicationProtocols" : [ "applicationProtocols", "applicationProtocols" ],
            "transportProtocol" : "TCP"
          }
        }
      },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "componentState" : {
        "localNodeStates" : [ {
          "state" : {
            "key" : "state"
          }
        }, {
          "state" : {
            "key" : "state"
          }
        } ],
        "clusterState" : {
          "key" : "clusterState"
        }
      },
      "controllerServiceApis" : [ {
        "type" : "type"
      }, {
        "type" : "type"
      } ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "properties" : {
        "key" : "properties"
      }
    }, {
      "annotationData" : "annotationData",
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "bulletinLevel" : "bulletinLevel",
      "propertyDescriptors" : {
        "key" : {
          "resourceDefinition" : {
            "resourceTypes" : [ "FILE", "FILE" ],
            "cardinality" : "SINGLE"
          },
          "displayName" : "displayName",
          "identifiesControllerService" : true,
          "name" : "name",
          "dynamic" : true,
          "sensitive" : true,
          "listenPortDefinition" : {
            "applicationProtocols" : [ "applicationProtocols", "applicationProtocols" ],
            "transportProtocol" : "TCP"
          }
        }
      },
      "type" : "type",
      "scheduledState" : "ENABLED",
      "componentState" : {
        "localNodeStates" : [ {
          "state" : {
            "key" : "state"
          }
        }, {
          "state" : {
            "key" : "state"
          }
        } ],
        "clusterState" : {
          "key" : "clusterState"
        }
      },
      "controllerServiceApis" : [ {
        "type" : "type"
      }, {
        "type" : "type"
      } ],
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "groupIdentifier" : "groupIdentifier",
      "bundle" : {
        "artifact" : "artifact",
        "version" : "version",
        "group" : "group"
      },
      "properties" : {
        "key" : "properties"
      }
    } ],
    "defaultFlowFileExpiration" : "defaultFlowFileExpiration",
    "flowFileConcurrency" : "flowFileConcurrency",
    "flowFileOutboundPolicy" : "flowFileOutboundPolicy",
    "name" : "name",
    "inputPorts" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "allowRemoteAccess" : true,
      "concurrentlySchedulableTaskCount" : 7,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "portFunction" : "STANDARD",
      "groupIdentifier" : "groupIdentifier",
      "type" : "INPUT_PORT",
      "scheduledState" : "ENABLED"
    }, {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "allowRemoteAccess" : true,
      "concurrentlySchedulableTaskCount" : 7,
      "name" : "name",
      "instanceIdentifier" : "instanceIdentifier",
      "portFunction" : "STANDARD",
      "groupIdentifier" : "groupIdentifier",
      "type" : "INPUT_PORT",
      "scheduledState" : "ENABLED"
    } ],
    "instanceIdentifier" : "instanceIdentifier",
    "maxConcurrentTasks" : 4,
    "statelessFlowTimeout" : "statelessFlowTimeout",
    "groupIdentifier" : "groupIdentifier",
    "remoteProcessGroups" : [ {
      "componentType" : "CONNECTION",
      "identifier" : "identifier",
      "comments" : "comments",
      "proxyPassword" : "proxyPassword",
      "communicationsTimeout" : "communicationsTimeout",
      "proxyHost" : "proxyHost",
      "proxyPort" : 7,
      "outputPorts" : [ null, null ],
      "transportProtocol" : "transportProtocol",
      "name" : "name",
      "proxyUser" : "proxyUser",
      "inputPorts" : [ {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      }, {
        "componentType" : "CONNECTION",
        "identifier" : "identifier",
        "remoteGroupId" : "remoteGroupId",
        "comments" : "comments",
        "targetId" : "targetId",
        "concurrentlySchedulableTaskCount" : 6,
        "useCompression" : true,
        "scheduledState" : "ENABLED",
        "name" : "name",
        "instanceIdentifier" : "instanceIdentifier",
        "batchSize" : {
          "duration" : "duration",
          "size" : "size",
          "count" : 1
        },
        "groupIdentifier" : "groupIdentifier"
      } ],
      "targetUris" : "targetUris",
      "instanceIdentifier" : "instanceIdentifier",
      "yieldDuration" : "yieldDuration",
[...]
